com.holonplatform.vaadin.components.builders

## Interface BaseItemDataSourceComponentBuilder<B extends BaseItemDataSourceComponentBuilder<B>>

- Type Parameters:
    `B` - Concrete builder type
  All Superinterfaces:
    ComponentConfigurator<B>
  All Known Subinterfaces:
    BeanListingBuilder<T>, ItemDataSourceComponentBuilder<ITEM,C,B>, ItemListingBuilder<T,P,C,B,X>, ItemListingBuilder.BaseGridItemListingBuilder<T,P,C,B>, ItemListingBuilder.GridItemListingBuilder<T,C,B>, PropertyListingBuilder<C,B,X>, PropertyListingBuilder.BaseGridPropertyListingBuilder<C,B>, PropertyListingBuilder.GridPropertyListingBuilder

      public interface BaseItemDataSourceComponentBuilder<B extends BaseItemDataSourceComponentBuilder<B>>
      extends ComponentConfigurator<B>

  Base builder for components with `ItemDataSource` support.
  Since:
    5.0.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `ComponentConfigurator.BaseComponentConfigurator`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `B` | `autoRefresh(boolean autoRefresh)` Set if auto-refresh is enabled for this container, i.e. items are loaded when one of the Container method which involve operations on item set is called.
    `B` | `batchSize(int batchSize)` Set batch (page) size for items loading using `ItemDataProvider`.
    `B` | `defaultSort(com.holonplatform.core.query.QuerySort sort)` Set query default sort.
    `B` | `fixedFilter(com.holonplatform.core.query.QueryFilter filter)` Set query fixed filter (always added to query predicates)
    `B` | `fixedSort(com.holonplatform.core.query.QuerySort sort)` Set query fixed sort (always added to query sorts)
    `B` | `maxCacheSize(int maxCacheSize)` Set max items cache size when in buffered mode.
    `B` | `queryParameter(String name, Object value)` Add a query parameter
    `B` | `withQueryConfigurationProvider(com.holonplatform.core.query.QueryConfigurationProvider queryConfigurationProvider)` Add an external `QueryConfigurationProvider` for additional query configuration

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `caption, caption, caption, captionAsHtml, description, description, description, disabled, errorHandler, fullHeight, fullSize, fullWidth, height, height, heightUndefined, hidden, icon, id, notVisible, primaryStyleName, replaceStyleName, responsive, sizeUndefined, styleName, width, width, widthUndefined, withAttachListener, withContextClickListener, withData, withDetachListener, withShortcutListener`

- - ### Method Detail

    - #### autoRefresh

          B autoRefresh(boolean autoRefresh)

      Set if auto-refresh is enabled for this container, i.e. items are loaded when one of the Container method which involve operations on item set is called.

      If auto-refresh is not enabled, `ItemDataSource.refresh()` method must be called to load items before using this Container.

      Parameters:
        `autoRefresh` - `true` to enable auto-refresh
      Returns:
        this

    - #### batchSize

          B batchSize(int batchSize)

      Set batch (page) size for items loading using `ItemDataProvider`.

      A value `<=0` means no paging, and `ItemDataProvider` should behave in a consistent manner.

      Parameters:
        `batchSize` - Batch (page) size for items loading
      Returns:
        this

    - #### maxCacheSize

          B maxCacheSize(int maxCacheSize)

      Set max items cache size when in buffered mode.
      Parameters:
        `maxCacheSize` - Max cache size to set
      Returns:
        this

    - #### withQueryConfigurationProvider

          B withQueryConfigurationProvider(com.holonplatform.core.query.QueryConfigurationProvider queryConfigurationProvider)

      Add an external `QueryConfigurationProvider` for additional query configuration
      Parameters:
        `queryConfigurationProvider` - QueryConfigurationProvider to add
      Returns:
        this

    - #### fixedFilter

          B fixedFilter(com.holonplatform.core.query.QueryFilter filter)

      Set query fixed filter (always added to query predicates)
      Parameters:
        `filter` - Query fixed filter, or `null` for none
      Returns:
        this

    - #### fixedSort

          B fixedSort(com.holonplatform.core.query.QuerySort sort)

      Set query fixed sort (always added to query sorts)
      Parameters:
        `sort` - Query fixed sort, or `null` for none
      Returns:
        this

    - #### defaultSort

          B defaultSort(com.holonplatform.core.query.QuerySort sort)

      Set query default sort. If not `null` and no other sort is available, this one will be used
      Parameters:
        `sort` - Default query sort
      Returns:
        this

    - #### queryParameter

          B queryParameter(String name,
                           Object value)

      Add a query parameter
      Parameters:
        `name` - Parameter name
        `value` - Parameter value
      Returns:
        this

Copyright © 2019 The Holon Platform. All rights reserved.